// This file was generated by gir (https://github.com/gtk-rs/gir)
// from ..
// from ../gir-files
// DO NOT EDIT

use glib::{prelude::*};
use std::{fmt};

glib::wrapper! {
    #[doc(alias = "GoaChat")]
    pub struct Chat(Interface<ffi::GoaChat, ffi::GoaChatIface>);

    match fn {
        type_ => || ffi::goa_chat_get_type(),
    }
}

impl Chat {
        pub const NONE: Option<&'static Chat> = None;
    

    //#[doc(alias = "goa_chat_interface_info")]
    //pub fn interface_info() -> /*Ignored*/Option<gio::DBusInterfaceInfo> {
    //    unsafe { TODO: call ffi:goa_chat_interface_info() }
    //}

    //#[doc(alias = "goa_chat_override_properties")]
    //pub fn override_properties(klass: /*Ignored*/&mut glib::ObjectClass, property_id_begin: u32) -> u32 {
    //    unsafe { TODO: call ffi:goa_chat_override_properties() }
    //}
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Chat>> Sealed for T {}
}

pub trait ChatExt: IsA<Chat> + sealed::Sealed + 'static {}

impl<O: IsA<Chat>> ChatExt for O {}

impl fmt::Display for Chat {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("Chat")
    }
}
